#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"

//#include "resource\BitStageFont.h"
#include "resource\BGFont.h"

#include <stdlib.h>

//const int __gba_multiboot;	//GBANp

//BG2    
//BG3    wiAAvC[

#define TRUE  (1)
#define FALSE (0)

#define STAGE_MAX_X   11
#define STAGE_MAX_Y   11
#define STAGE_MAX_CNT  1

//BG\ɎgLN^[
#define BG_CHARACTER_BLANK  0x0000		// ' '  
#define BG_CHARACTER_BOX    0x0001		// '$'  
#define BG_CHARACTER_PLACE  0x0002		// '.'  ̒uꏊ
#define BG_CHARACTER_WALL   0x0003		// '#'  
#define BG_CHARACTER_PLAYER 0x0004		// '@'  vC[
#define BG_CHARACTER_ERROR  0x0005		//      G[p
//---------------------------------------------------------------------------
typedef struct {
	u8  x;
	u8  y;
}ST_PLAYER;

ST_PLAYER PLAYER;

//Q[Ɏg}bvf[^
u8 GameStage[STAGE_MAX_X][STAGE_MAX_Y];
//ǂݍ݂Ɏg}bvf[^
u8 LoadStage[STAGE_MAX_X][STAGE_MAX_Y] = {
		{' ',' ',' ','#','#','#',' ',' ',' ',' ',' '},
		{' ',' ','#','#',' ','#',' ','#','#','#','#'},
		{' ','#','#',' ',' ','#','#','#',' ',' ','#'},
		{'#','#',' ','$',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ','@','$',' ','#',' ',' ','#'},
		{'#','#','#',' ','$','#','#','#',' ',' ','#'},
		{' ',' ','#',' ',' ','#','.','.',' ',' ','#'},
		{' ','#','#',' ','#','#','.','#',' ','#','#'},
		{' ','#',' ',' ',' ',' ',' ',' ','#','#',' '},
		{' ','#',' ',' ',' ',' ',' ','#','#',' ',' '},
		{' ','#','#','#','#','#','#','#',' ',' ',' '},
  };
//---------------------------------------------------------------------------
u8 BG2Chr;
u8 BG2Map;
u8 BG3Chr;
u8 BG3Map;
u8 BG3Col;

u8 StageEndFlag;	//rs`fdItO
u8 StageCnt;		//H̃Xe[W
u8 WalkCnt;			//s
//---------------------------------------------------------------------------
void Init();
void InitBG();
void InitGame();
void InitStage();

void InputPlayer();
void CalcPlayer(u8,u8);

void MovePlayer(u8,u8);
void MoveBox(u8,u8,u8,u8);

void DrawPlayer();
void DrawScore();
void DrawBlock(u8,u8);

void ChkStageClear();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitBG();
	SetMode(MODE_0 | BG2_ENABLE | BG3_ENABLE);

	for(;;)
	{
		if(StageCnt >= STAGE_MAX_CNT)
		{
			break;
		}

		//Xe[WI
		InitGame();
		InitStage();

		//Q[Jn
		while(StageEndFlag == FALSE)
		{
			InputPlayer();
			DrawPlayer();
			DrawScore();

			ChkStageClear();
		}
	}

	BGDrawStr(BG2Map, 2, 14, " --- Game Clear! --- ");
	for(;;){}

	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	StageCnt = 0;
}
//---------------------------------------------------------------------------
void InitGame()
{
	PLAYER.x     = 0;
	PLAYER.y     = 0;
	WalkCnt      = 0;
	StageEndFlag = FALSE;

	BGDrawCls(BG2Map, 0x0000);
	BGDrawCls(BG3Map, 0x0005);
	DrawPlayer();
	DrawScore();
}
//---------------------------------------------------------------------------
void InitStage()
{
	StageCnt++;

	//Xe[Wǂݍ
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			GameStage[x][y] = LoadStage[y][x];
			DrawBlock(x, y);

			//vC[̖ڈ́A󔒂Ɉɂ
			if(GameStage[x][y] == '@')
			{
				GameStage[x][y] = ' ';
				PLAYER.x = x;
				PLAYER.y = y;
			}
		}
	}
}
//---------------------------------------------------------------------------
void InitBG()
{
	//BG2 
	//BG3 wiAAvC[

	BG2Map = 0;
	BG3Map = 1;

	BG2Chr = 1;
	BG3Chr = 2;

	BG3Col = 1;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);
	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 0);

	//Palette
	BGSetPal16(0, (u16*)BGFont_palette);
	BGSetPal16(1, (u16*)EtfsGetDataOffset(_BACKGROUND_IMG_PAL_OFFSET));

	//ChrData
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);
	BGSetChrData(BG3Chr, (u16*)EtfsGetDataOffset(_BACKGROUND_IMG_BIN_OFFSET), _BACKGROUND_IMG_BIN_SIZE);
}
//---------------------------------------------------------------------------
void InputPlayer()
{
	u8 Key;
	KeyInitialize();

	for(;;)
	{
		Key = KeyInput();
		
		if(Key & KEY_UP   ) { CalcPlayer(PLAYER.x,   PLAYER.y-1); break; }
		if(Key & KEY_DOWN ) { CalcPlayer(PLAYER.x,   PLAYER.y+1); break; }
		if(Key & KEY_LEFT ) { CalcPlayer(PLAYER.x-1, PLAYER.y);   break; }
		if(Key & KEY_RIGHT) { CalcPlayer(PLAYER.x+1, PLAYER.y);   break; }
		if(Key & KEY_B)     { StageEndFlag = TRUE; StageCnt--;    break; }
	}

	while(*KEYS != 0x3ff){}		//͂ɂȂ܂ő҂
}
//---------------------------------------------------------------------------
void MovePlayer(u8 x, u8 y)
{
	//ړǑn
	DrawBlock(PLAYER.x, PLAYER.y);

	PLAYER.x = x;
	PLAYER.y = y;
	WalkCnt++;
}
//---------------------------------------------------------------------------
void CalcPlayer(u8 moveX, u8 moveY)
{
	//ړ͉邩i[
	u8 moveR = GameStage[moveX][moveY];

	//ǁH
	if(moveR == '#')
	{
		return;
	}
	//󔒁A͒uꏊH
	if(moveR == ' ' || moveR == '.')
	{
		MovePlayer(moveX, moveY);
		return;
	}
	//H
	if(moveR == '$' || moveR == '*')
	{
		//Ɏ̈ړ́H
		u8 nextMoveX = moveX + (moveX - PLAYER.x);
		u8 nextMoveY = moveY + (moveY - PLAYER.y);
		u8 nextMoveR = GameStage[nextMoveX][nextMoveY];

		//󔒁A̒uꏊ
		if(nextMoveR == ' ' || nextMoveR == '.')
		{
			MoveBox   (moveX, moveY, nextMoveX, nextMoveY);
			MovePlayer(moveX, moveY);
		}
	}
}
//---------------------------------------------------------------------------
//̈ړ
void MoveBox(u8 srcX, u8 srcY, u8 destX, u8 destY)
{
	//ړO
	if(GameStage[srcX][srcY] ==  '*')   GameStage[srcX][srcY] = '.';
	else                                GameStage[srcX][srcY] = ' ';

	//ړ
	if(GameStage[destX][destY] ==  '.') GameStage[destX][destY] = '*';
	else                                GameStage[destX][destY] = '$';

//	DrawBlock(srcX , srcY );
	DrawBlock(destX, destY);
}
//---------------------------------------------------------------------------
void ChkStageClear()
{
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			if(GameStage[x][y] == '.')
			{
				return;
			}
		}
	}
	StageEndFlag = TRUE;
}
//---------------------------------------------------------------------------
void DrawBlock(u8 x,u8 y)
{
	switch(GameStage[x][y])
	{
	case '*':
	case '$': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_BOX);    break;
	case ' ': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_BLANK);  break;
	case '.': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_PLACE);  break;
	case '#': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_WALL);   break;
	case '@': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_PLAYER); break;

	default:
		BGDrawChar(BG3Map, x, y, BG3Col, BG_CHARACTER_ERROR);
		dprintf("Error DrawBlock --- %d,%d \n", x, y);
		break;
	}
}
//---------------------------------------------------------------------------
void DrawPlayer()
{
	WaitForVsync();
	BGDrawChar(BG3Map, PLAYER.x, PLAYER.y, BG3Col, BG_CHARACTER_PLAYER);
}
//---------------------------------------------------------------------------
void DrawScore()
{
	u8 Score[256];
	bprintf(Score, "Level:%d Walk:%d    ", StageCnt, WalkCnt);

	WaitForVsync();
	BGDrawStr(BG2Map, 0, 18, Score);
}
